;                      4.1
;  楤  뢠 ࠬ஢ ஫ IDE
;
;  ⥪ ணࠬ 㫠  쥢.
;  lst04_01.inc, 07.02.2001.

DATASEG
; 饭  ⢨ ⮢ ⥬,
; 室  ᪠ ਬ
NoPCI  DB LIGHTRED,12,18
       DB "⥬  ন 䥩 PCI BIOS",0
NoIDEC DB LIGHTRED,12,26
       DB "஫ PCI IDE  ",0
BadReg DB LIGHTRED,12,28,"  ॣ",0
; न ன⢠ PCI
BusNumber      DB ? ; 設
DeviceNumber   DB ? ; ன⢠   㭪樨
; 䨪 ன⢠ PCI
VendorID       DW ? ;䨪 ⮢⥫
DeviceID       DW ? ;䨪 ன⢠
;   ॣ஢ ஫ PCI IDE
IDEContrRegsBaseAddr DW ?
ENDS

CODESEG
;***************************************************
;*   IDE     *
;* 楤   室 ࠬ஢.          *
;*  砥 ᯥ譮 襭 樨 ᪠   *
;* ࠬ ஫ ࠭    *
;* ६ BusNumber, DeviceNumber, VendorID,   *
;* DeviceID  IDEContrRegsBaseAddr.                *
;***************************************************
PROC SearchBusMasterIDEContr near
        pushad
; ஢ 稥 PCI BIOS
        mov     AX,0B101h
        int     1Ah
        jc      @@PCIBIOSNotFound
        cmp     EDX,20494350h
        jne     @@PCIBIOSNotFound
;  ஫ Bus Master IDE   
        mov     AX,0B103h
        mov     ECX,010180h  ; ਠ 
        mov     SI,0
        int     1Ah
        jnc     @@ReadPCIRegisters ;ன⢮ 
        mov     AX,0B103h
        mov     ECX,010185h  ;ன ਠ 
        mov     SI,0
        int     1Ah
        jnc     @@ReadPCIRegisters ;ன⢮ 
        mov     AX,0B103h
        mov     ECX,01018Ah  ;⨩ ਠ 
        mov     SI,0
        int     1Ah
        jnc     @@ReadPCIRegisters ;ன⢮ 
; ஫ IDE  
        mov     SI,offset NoIDEC
        call    FatalError
; ன⢮ 㦥,  न  設 PCI
; 室  ॣ BX
@@ReadPCIRegisters:
;  न ஫
        mov     [BusNumber],BH
        mov     [DeviceNumber],BL
;  䨪 ⮢⥫
        mov     AX,0B109h ; ᫮
        mov     DI,0      ;ᬥ饭 ᫮
        int     1Ah
        jc      @@BadRegisterNumber
        mov     [VendorID],CX
;  䨪 ன⢠
        mov     AX,0B109h ; ᫮
        mov     DI,2      ;ᬥ饭 ᫮
        int     1Ah
        jc      @@BadRegisterNumber
        mov     [DeviceID],CX
;     ॣ஢ ஫ IDE
        mov     AX,0B10Ah ;  ᫮
        mov     DI,20h    ;ᬥ饭 ᫮
        int     1Ah
        jc      @@BadRegisterNumber
        and     CX,0FFF0h ; 訥 4 ࠧ鸞
        mov     [IDEContrRegsBaseAddr],CX
        popad
        ret

; ࠡ⪠ 訡
@@PCIBIOSNotFound:
        ;  ন PCI BIOS
        mov     SI,offset NoPCI
        call    FatalError
@@BadRegisterNumber:
        ;   ॣ
        mov     SI,offset BadReg
        call    FatalError
ENDP SearchBusMasterIDEContr
ENDS
