;                      11.4
;   楤  ᪠ CD-᪮  ।
;                     ࠬ஢
;
;  ⥪ ணࠬ 㫠  쥢.
;  lst11_04.inc, 4.02.2001.

DATASEG
; 饭  ਩ 襭 ணࠬ
CDNotFoundTxt DB LIGHTRED,12,31,"᪮  ",0
;   ࠬ஢ ன⢠
CDTxt  DB 2,27,"       .",0
       DB 4,25,"ࠬ 㦥 ᪠:",0
       DB 6,22," ଠ:",0
       DB 7,24,"਩ :",0
       DB 8,32,":",0
       DB 9,27,":",0
       DB 10,13,"ন ० DMA:",0
       DB 11,17,"襭 ० PIO:",0
CDAnyK DB YELLOW,24,29,"  ",0
;    ਥ 䨪樮 ଠ樨
Sector512 DB 512 DUP (?)
ENDS

CODESEG
;*************************************************
;*        ATAPI    *
;* 室 ࠬ । १  *
;* ଥ:                                    *
;* ChannelNumber -  ;                 *
;* DiskNumber -  ᪠  .           *
;* 䨪樮   뢠     *
;*  ᨢ Sector512.                           *
;*************************************************
PROC ReadCD_ID near
        pushad
        push    ES
;  ० CHS
        mov     [ATAAddressMode],0
; ᫠  䨪樨 ன⢠
        mov     [ATAFeatures],0
        mov     [ATASectorCount],0
        mov     [ATASectorNumber],0
        mov     [ATACylinder],0
        mov     [ATAHead],0
        mov     [ATACommand],0A1h
        call    SendCommandToHDD
        cmp     [DevErrorCode],0 ;஢  訡
        jne     @@End  ;, ࠭  訡
;  ⮢  HDD
        mov     DX,[ATABasePortAddr]
        add     DX,7   ; 17h
@@WaitCompleet:
        ; ஢ ६
        mov     EAX,[ES:046Ch]
        sub     EAX,[OpTime]
        cmp     EAX,MaxHDDWaitTime
        ja      @@Error1 ;訡 ⠩-
        ; ஢ ⮢
        in      AL,DX
        test    AL,80h   ;ﭨ ᨣ BSY
        jnz     @@WaitCompleet
        test    AL,1     ;ﭨ ᨣ ERR
        jnz     @@Error6
        test    AL,08h   ;ﭨ ᨣ DRQ
        jz      @@WaitCompleet
; ਭ    ஫
        mov     AX,DS
        mov     ES,AX
        mov     DI,offset Sector512
        mov     DX,[ATABasePortAddr] ; 1x0h
        mov     CX,256 ;᫮ 뢠 ᫮
        rep     insw
        jmp short @@End
;   訡
@@Error1:
        mov     [DevErrorCode],1
        jmp short @@End
@@Error6:
        mov     [DevErrorCode],6
@@End:  pop     ES
        popad
        ret
ENDP ReadCD_ID


;***************************************************
;*                ATAPI             *
;*  砥 ᯥ譮 襭 ᪠:           *
;* -    ன⢠ ࠭ *
;*    ATABasePortAddr;                            *
;* -   ࠭  ChannelNumber;     *
;* -  ன⢠ ࠭  DiskNumber.    *
;*  砥, ᫨ ன⢮  ,           *
;* ந ਩ 室  ணࠬ.      *
;***************************************************
PROC FindATAPIDevice NEAR
        pusha
; ஢ ४⭮ 砫 祭 ࠬ஢
        mov     [ChannelNumber],1
;   
@@AskMaster:
        ;  Master-
        mov     [DiskNumber],0
        call    DeviceReset
        cmp     [DevErrorCode],0
        jne     @@AskSlave     ;ன⢮  ॠ
        call    ReadCD_ID
        cmp     [DevErrorCode],0
        je      @@DiskFound    ;室  横 ᪠
@@AskSlave:
        ;  Slave-
        mov     [DiskNumber],1
        call    DeviceReset
        cmp     [DevErrorCode],0
        jne     @@NextCannel   ;ன⢮  ॠ
        call    ReadCD_ID
        cmp     [DevErrorCode],0
        je      @@DiskFound    ;室  横 ᪠
@@NextCannel:
        inc     [ChannelNumber]
        cmp     [ChannelNumber],3
        jb      @@AskMaster    ; ᫥騩 
; ᪮   - ਩ 室  DOS
        call    ClearScreen
        mov     SI,offset CDNotFoundTxt
        call    ShowColorString
        mov     AH,4Ch ;室  DOS
        int     21h
; ᪮ 
@@DiskFound:
        popa
        ret
ENDP FindATAPIDevice


;*****************************************************
;*                     *
;* ஢뢠 ଠ  512-⭮  *
;* , ࠧ饭  ᨢ Sector512.         *
;*****************************************************
PROC ShowCD_ID near
        pusha
; ⠭  梥   䮭
        mov     [TextColorAndBackground],LIGHTGREEN
; 뢥  
        MShowText 8,CDTxt
; ⠭  梥   䮭
        mov     [TextColorAndBackground],WHITE
; 뢥     ᪠
        MShowDecWord 2,37,[ChannelNumber]
        MShowDecByte 2,51,[DiskNumber]
; 뢥 ⤥  䨪
; (⮫쪮 ᯥ᪨)
        ;  ଠ
        MShowBinWord 6,40,<[word ptr Sector512]>
        ; ਩ 
        mov     AX,0B800h
        mov     ES,AX
        mov     SI,offset Sector512
        add     SI,10*2
        mov     DI,(7*80+40)*2
        mov     AH,[TextColorAndBackground]
        mov     CX,10
@@NextWord1:
        mov     DX,[SI]
        mov     AL,DH
        stosw
        mov     AL,DL
        stosw
        add     SI,2
        loop    @@NextWord1
        ;  
        mov     SI,offset Sector512
        add     SI,27*2
        mov     DI,(8*80+40)*2
        mov     AH,[TextColorAndBackground]
        mov     CX,20
@@NextWord2:
        mov     DX,[SI]
        mov     AL,DH
        stosw
        mov     AL,DL
        stosw
        add     SI,2
        loop    @@NextWord2
        ; 
        MShowBinWord 9,40,<[word ptr Sector512+49*2]>
        ; ন ० DMA
        MShowBinByte 10,40,<[Sector512+63*2]>
        ; 祭 ᫮ 64-70 ⮢?
        test    [word ptr Sector512+53*2],10b
        jz      @@NotValid6470
        ; ন ० PIO
        MShowBinByte 11,40,<[Sector512+64*2]>
@@NotValid6470:
; 뢥 㪠 
        MShowColorText 1,CDAnyK
;    
        call    GetChar
        popa
        ret
ENDP ShowCD_ID
ENDS
