;                      11.2
;   楤  ᪠ ⪮ ᪠, ।
;           ࠬ஢  뢠 
;
;  ⥪ ணࠬ 㫠  쥢.
;  lst11_02.inc, 4.02.2001.

DATASEG
; 饭  㤠筮 襭 ᪠
DiskNotFoundTxt DB LIGHTRED,12,33,"  ",0
;  뢠 ᥪ  ० LBA
SectorAddress   DD ?
; ࠢ ᨢ    ᠬ
; (室 ⮫쪮  ० DMA)
EVEN 
;    ਥ ଠ樨  ᪠
Sector512 DB 512 DUP (?)
ENDS

CODESEG
;*************************************************
;*              *
;* 室 ࠬ । १  *
;* ६:                                   *
;* ChannelNumber -   (1  2);       *
;* DiskNumber -  ᪠   (0  1). *
;* 䨪樮   뢠     *
;*  ᨢ Sector512.                           *
;*************************************************
PROC ReadHDD_ID near
        pushad
        push    ES
;  ० CHS
        mov     [ATAAddressMode],0
; ᫠  䨪樨 ன⢠
        mov     [ATAFeatures],0
        mov     [ATAHead],0
        mov     [ATACommand],0ECh
        call    SendCommandToHDD
        cmp     [DevErrorCode],0 ;஢  訡
        jne     @@End  ;, ࠭  訡
;  ⮢  HDD
        mov     AX,0
        mov     ES,AX
        mov     DX,[ATABasePortAddr]
        add     DX,7     ; ॣ ﭨ
@@WaitCompleet:
        ; ஢ ६ 믮 
        mov     EAX,[ES:046Ch]
        sub     EAX,[OpTime]
        cmp     EAX,MaxHDDWaitTime
        ja      @@Error1 ;訡 ⠩-
        ; ஢ ⮢
        in      AL,DX
        test    AL,80h   ;ﭨ ᨣ BSY
        jnz     @@WaitCompleet
        test    AL,1     ;ﭨ ᨣ ERR
        jnz     @@Error6
        test    AL,08h   ;ﭨ ᨣ DRQ
        jz      @@WaitCompleet
; ਭ    ஫
        mov     AX,DS
        mov     ES,AX
        mov     DI,offset Sector512
        mov     DX,[ATABasePortAddr] ;ॣ 
        mov     CX,256   ;᫮ 뢠 ᫮
        rep     insw     ;ਭ  
        jmp short @@End
;   訡
@@Error1:
        mov     [DevErrorCode],1
        jmp short @@End
@@Error6:
        mov     [DevErrorCode],6
@@End:  pop     ES
        popad
        ret
ENDP ReadHDD_ID


;****************************************************
;*                                    *
;*  ந ⮫쪮   1  2,  *
;*  㤥 㦥   ( C:)    *
;*  襭  .                       *
;* 室 ࠬ஢ 楤  .           *
;*  砥 ᯥ譮 襭 ᪠:            *
;* -    ன⢠ ࠭  *
;*    ATABasePortAddr;                             *
;* -   ࠭  ChannelNumber;      *
;* -  ன⢠ ࠭  DiskNumber.     *
;*  砥, ᫨ ன⢮  ,            *
;* ந ਩ 室  ணࠬ.       *
;****************************************************
PROC FindHDD near
        pusha
; ⠭ 砫  
        mov     [ChannelNumber],1
;   
@@AskMaster:
        ;  Master-
        mov     [DiskNumber],0
        call    ReadHDD_ID
        cmp     [DevErrorCode],0
        je      @@DiskFound    ;室  横 ᪠
@@AskSlave:
        ;  Slave-
        mov     [DiskNumber],1
        call    ReadHDD_ID
        cmp     [DevErrorCode],0
        je      @@DiskFound    ;室  横 ᪠
@@NextCannel:
        inc     [ChannelNumber]
        cmp     [ChannelNumber],3
        jb      @@AskMaster    ; ᫥騩 
; ᪮   - ਩ 室  DOS
        call    ClearScreen
        mov     SI,offset DiskNotFoundTxt
        call    ShowColorString
        mov     AH,4Ch ;室  DOS
	int     21h
; ᪮ 
@@DiskFound:
        popa
        ret
ENDP FindHDD


;*************************************************
;*        LBA   *
;* 室 ࠬ । १  *
;* ଥ:                                    *
;* ChannelNumber -   (1  2);       *
;* DiskNumber -  ᪠   (0  1); *
;* SectorAddress -  뢠 ᥪ.   *
;*  뢠 ᭮ ᥣ ,   *
;*  ᨢ Sector512.                           *
;*************************************************
PROC ReadHDDSector NEAR
        pushad
        push    ES
;  ० LBA
        mov     [ATAAddressMode],1
; ᫠  ⥭ ᥪ ( ࠬ)
        mov     [ATAFeatures],0
        mov     [ATASectorCount],1
        mov     EAX,[SectorAddress]
        mov     [dword ptr ATASectorNumber],EAX
        mov     [ATACommand],20h
        call    SendCommandToHDD
        cmp     [DevErrorCode],0
        jne     @@End    ;, ࠭  訡
;  ⮢  HDD
        mov     AX,0
        mov     ES,AX
        mov     DX,[ATABasePortAddr]
        add     DX,7     ; ॣ ﭨ
@@WaitCompleet:
        ; ஢ ६ 믮 
        mov     EAX,[ES:046Ch]
        sub     EAX,[OpTime]
        cmp     EAX,MaxHDDWaitTime
        ja      @@Error1 ;訡 ⠩-
        ; ஢ ⮢
        in      AL,DX
        test    AL,80h   ;ﭨ ᨣ BSY
        jnz     @@WaitCompleet
        test    AL,08h   ;ﭨ ᨣ DRQ
        jz      @@WaitCompleet
; ਭ ᥪ
        mov     AX,DS
        mov     ES,AX
        mov     DI,offset Sector512
        mov     DX,[ATABasePortAddr] ;ॣ 
        mov     CX,256   ;᫮ 뢠 ᫮
        rep     insw     ;ਭ  
;  ਧ 訡
        mov     [DevErrorCode],0
        jmp short @@End
;   訡
@@Error1:
        mov     [DevErrorCode],1 ;訡 ⠩-
        jmp short @@End
@@End:  pop     ES
        popad
        ret
ENDP ReadHDDSector
ENDS
