;                      11.6
;        ४祭 ⪮ ᪠  ० Standby
;
;  ⥪ ணࠬ 㫠  쥢.
;  lst11_06.asm, 23.02.2001.

IDEAL
P386
LOCALS
MODEL MEDIUM

;  䠩 ᪨ 祭
;  ࠢ   梥⮢ 
include "lst03_01.inc"
;  䠩 ᮢ
include "lst03_04.inc"

DATASEG
;  ࠭
Txt1 DB LIGHTGREEN,12,30,"  ",0
Txt2 DB YELLOW,12,24,"    STANDBY",0
;   
TxtW DB YELLOW,24,35," ...",0
AnyK DB YELLOW,24,29,"  ",0
; 饭  訡
CErr DB LIGHTRED,12,21
     DB "    STANDBY",0
ENDS

SEGMENT sseg para stack 'STACK'
        DB 400h DUP(?)
ENDS

CODESEG
;*****************************
;* ᭮  ணࠬ *
;*****************************
PROC SetStandbyMode
        mov     AX,DGROUP
        mov     DS,AX
; ⠭ ⥪⮢ ०   ࠭
        mov     AX,3
        int     10h
;   -    ࠭ ࠭
        mov     [ScreenString],25
        mov     [ScreenColumn],0
        call    SetCursorPosition
; 뢥  ࠭
        MShowColorText 1,Txt1
        MShowColorText 1,TxtW
;  ⪨  "C:"
        call    FindHDD

;  ⮢ HDD  ਥ 
        ;  ६ 砫 樨  ᪮
        mov     AX,0
        mov     ES,AX
        mov     EAX,[ES:046Ch]
        mov     [OpTime],EAX
        ;  㦭 
        mov     DX,[ATABasePortAddr]
        add     DX,6    ; ॣ 
        mov     AL,[DiskNumber]
        shl     AL,4
        or      AL,10100000b
        out     DX,AL
        ; ,    㤥 ⮢
        inc     DX      ; DX  ॣ ﭨ
@@WaitHDReady:
        ; ஢ ६ 믮 
        mov     EAX,[ES:046Ch]
        sub     EAX,[OpTime]
        cmp     EAX,BSYWaitTime
        ja      @@Err   ;訡 ⠩-
        ;  ॣ ﭨ
        in      AL,DX
        ; ஢ ﭨ ᨣ BSY
        test    AL,80h
        jnz     @@WaitHDReady
        ; ஢ ﭨ ᨣ DRQ
        test    AL,08h
        jnz     @@WaitHDReady
;    ॢ ᪠  ० Standby
        mov     AL,0E0h ;  Standby
        out     DX,AL
;  襭 
@@WaitCompleet:
        ; ஢ ६ 믮 
        mov     EAX,[ES:046Ch]
        sub     EAX,[OpTime]
        cmp     EAX,MaxHDDWaitTime
        ja      @@Err    ;訡 ⠩-
        ; ஢ ⮢
        in      AL,DX
        test    AL,80h   ;ﭨ ᨣ BSY
        jnz     @@WaitCompleet
        test    AL,1     ;ﭨ ᨣ ERR
        jnz     @@Err

; 뢥 㪠  
        MShowColorText 1,Txt2
        MShowColorText 1,AnyK
;   
        call    GetChar
        jmp short @@Exit
; 뤠 ᮮ饭  訡
@@Err:  MShowColorText 1,CErr
        MShowColorText 1,AnyK
@@Exit:
; ⠭ ⥪⮢ ०
        mov     ax,3
        int     10h
; 室  DOS
        mov     AH,4Ch
        int     21h
ENDP SetStandbyMode
ENDS

;  楤 /뢮
include "lst03_02.inc"
;  楤  ॢ ᥫ  筮
;   
include "lst03_03.inc"
;  楤   ATA-
include "lst11_01.inc"
;  楤  ᪠ ⪮ ᪠
include "lst11_02.inc"
END
