;                      11.7
;  뢠 㧮筮 ᥪ ⪮ ᪠ "C:"
;            ० LBA  ᯮ짮 DMA
;
;  ⥪ ணࠬ 㫠  쥢.
;  lst11_07.asm, 07.02.2001.

IDEAL
P386
LOCALS
MODEL MEDIUM

;  䠩 ᪨ 祭
;  ࠢ   梥⮢ 
include "lst03_01.inc"
;  䠩 ᮢ
include "lst03_04.inc"

DATASEG
; ⮢ ᮮ饭
Text0 DB LIGHTCYAN,0,10,"  "
      DB "   C:   DMA",0
Text1 DB YELLOW,5,8,"ন 㫥 ᥪ:",0
AnyK  DB YELLOW,24,29,"  ",0
NoHDD DB LIGHTRED,12,22
      DB " 祭   ࢮ ",0
NoLBA DB LIGHTRED,12,24
      DB "  ন ० LBA.",0
NoSec DB LIGHTRED,12,32,"  ",0
ENDS

;   ⠡ PRD
SEGMENT PRD_Table para public 'DATA'  
        DB 16 DUP(?)
ENDS

;   ਥ ᥪ   ० DMA
SEGMENT DMA_Sector512 para public 'DATA'  
        DB 512 DUP(?)
ENDS

SEGMENT sseg para stack 'STACK'
DB 400h DUP(?)
ENDS


CODESEG
;*****************************
;* ᭮  ணࠬ *
;*****************************
PROC IDE_DMA_Test
        mov     AX,DGROUP
        mov     DS,AX
; ⠭ ⥪⮢ ०   ࠭
        mov     AX,3
        int     10h
;   -    ࠭ ࠭
        mov     [ScreenString],25
        mov     [ScreenColumn],0
        call    SetCursorPosition
; 뢥 
        MShowColorText 1,Text0
;  ⪨  "C:"
        call    FindHDD
; ஢   (ணࠬ ⠭ 
; ᯮ짮 ⮫쪮 ࢮ )
        cmp     [ChannelNumber],1
        je      @@TestLBASupport
        mov     SI,offset NoHDD
        call    FatalError
@@TestLBASupport:
; ஢ 稥 প ० LBA
        cmp     [dword ptr Sector512+60*2],0
        jne     @@LBASupported
        mov     SI,offset NoLBA
        call    FatalError
@@LBASupported:
;  ஫ PCI IDE
        call    SearchBusMasterIDEContr
;  ⠡ PRD,    
        mov     AX,PRD_Table
        mov     ES,AX
        ; ᫨     
        xor     EAX,EAX
        mov     AX,DMA_Sector512
        shl     EAX,4
        mov     [ES:0],EAX
        ;  ⢮ । ⮢ 
        mov     [word ptr ES:4],512
        ; ⠭ ਧ ᫥ ப ⠡
        mov     [word ptr ES:6],8000h
; 㧨 䨧᪨  ⠡ PRD 
; ᮮ⢥騩 ॣ ஫ PCI IDE
        ; ᫨ ᮫  PRDT (㬭
        ;  ᥣ PRD_Table  16)
        xor     EAX,EAX
        mov     AX,PRD_Table
        shl     EAX,4
        ; ᫨  ॣ ஫
        mov     DX,[IDEContrRegsBaseAddr]
        add     DX,04h
        ;   PRD  ॣ
        out     DX,EAX
;  㫥 ᥪ ᪠  ० DMA
        call    ReadBootSector
;  ᮤন ⠭ ᥪ
        MShowColorText 1,Text1
        push    DS
        mov     AX,DMA_Sector512
        mov     DS,AX
        xor     SI,SI
        call    ShowSector512
        pop     DS
;    
        MShowColorText 1,AnyK
        call    GetChar
; ⠭ ⥪⮢ ०   ࠭
        mov     AX,3
        int     10h
; 室  DOS
        mov     AH,4Ch
        int     21h
ENDP IDE_DMA_Test 


;*********************************************
;*      DMA *
;*********************************************
PROC ReadBootSector near
        pushad
;  ࠧ 訡  뢠  ॣ
; ﭨ  1
;        mov     DX,[IDEContrRegsBaseAddr]
;        add     DX,02h
;        mov     AL,110b
;        out     DX,AL
; ந ஫ DMA     
;   1
        ; 㧨  ࠢ饣 ॣ  1
        mov     DX,[IDEContrRegsBaseAddr]
        ;  ࠢ騩 ॣ
        mov     AL,0
        out     DX,AL
        ; ⠭  ࠢ । 
        mov     AL,1000b
        out     DX,AL

; ᫠  ⥭ ᥪ 0 (㧮筮)
        ; ⮢ ࠬ 
        mov     [ATAAddressMode],1 ;० LBA
        mov     [dword ptr SectorAddress],0    ;ᥪ 0
        mov     [dword ptr ATASectorNumber],0
        mov     [ATAFeatures],0
        mov     [ATASectorCount],1 ;  ᥪ
        mov     EAX,[SectorAddress]
        ; ᫠  
        mov     [ATACommand],0C8h  ;⥭  ० DMA
        call    SendCommandToHDD
        ; ஢  訡
        cmp     [DevErrorCode],0   ; 訡?
        jne     @@Err

;  ࠧ 訡  뢠  ॣ
; ﭨ  1
        mov     DX,[IDEContrRegsBaseAddr]
        add     DX,02h
        mov     AL,110b
        out     DX,AL
; ⨢஢  1 ஫ DMA
        mov     DX,[IDEContrRegsBaseAddr]
        mov     AL,1001b
        out     DX,AL
;  ⮢  HDD
        mov     AX,0
        mov     ES,AX
        mov     DX,[ATABasePortAddr]
        add     DX,7     ; ॣ ﭨ
@@WaitCompleet:
        ; ஢ ६ 믮 
        mov     EAX,[ES:046Ch]
        sub     EAX,[OpTime]
        cmp     EAX,MaxHDDWaitTime
        ja      @@Err   ;訡 ⠩-
        ; ஢ ⮢
        in      AL,DX
        test    AL,88h   ;ﭨ ᨣ BSY  DRQ
        jnz     @@WaitCompleet
;   横 DMA
        mov     DX,[IDEContrRegsBaseAddr]
        add     DX,02h
@@WaitDMAOperationEnd:
        in      AL,DX
        test    AL,100b
        jz      @@WaitDMAOperationEnd

;  ࠢ騩 ॣ  1 ஫ DMA
        mov     DX,[IDEContrRegsBaseAddr]
        mov     AL,0
        out     DX,AL
        popad
        ret

; ࠡ⪠ 訡
@@Err:  mov     SI,offset NoSec
        call    FatalError
ENDP ReadBootSector
ENDS

;  楤 /뢮
include "lst03_02.inc"
;  楤 ᪠ ஫ PCI IDE
include "lst04_01.inc"
;  楤   ATA-
include "lst11_01.inc"
;  楤  ᪠ ⪮ ᪠
;  뢠  ࠬ஢
include "lst11_02.inc"
END
